﻿using System.Windows.Controls;

namespace TestProject
{
    /// <summary>
    /// 커스텀 잉크 캔버스
    /// </summary>
    public class CustomInkCanvas : InkCanvas
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 커스텀 동적 렌더러
        /// </summary>
        private CustomDynamicRenderer renderer = new CustomDynamicRenderer();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - CustomInkCanvas()

        /// <summary>
        /// 생성자
        /// </summary>
        public CustomInkCanvas() : base()
        {
            DynamicRenderer = this.renderer;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 스트로크 수집시 처리하기 - OnStrokeCollected(e)

        /// <summary>
        /// 스트로크 수집시 처리하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        protected override void OnStrokeCollected(InkCanvasStrokeCollectedEventArgs e)
        {
            Strokes.Remove(e.Stroke);

            CustomStroke stroke = new CustomStroke(e.Stroke.StylusPoints);

            Strokes.Add(stroke);

            InkCanvasStrokeCollectedEventArgs inkCanvasStrokeCollectedEventArgs = new InkCanvasStrokeCollectedEventArgs(stroke);

            base.OnStrokeCollected(inkCanvasStrokeCollectedEventArgs);
        }

        #endregion
    }
}